<template>
  <v-card v-if="seleccionable">
    <v-card-text v-if="seleccionable" :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
      <v-col class="mb-2">
        <v-row align="end">
          <v-spacer />
          <v-text-field
            v-model="search"
            append-icon="fal fa-search"
            label="Buscar"
            single-line
            color="accent"
            hide-details
            style="max-width: 40vh"
          />
        </v-row>
      </v-col>
      <v-expansion-panels
        hover
        flat
        multiple
        class="mt-8"
      >
        <v-expansion-panel>
          <v-expansion-panel-header color="rgba(141,88,193,0.34)">
            <v-row justify="start" align="center">
              <v-icon class="mr-2">
                fal fa-filter
              </v-icon><label>Filtros</label>
            </v-row>
          </v-expansion-panel-header>
          <v-expansion-panel-content :class="!$vuetify.theme.dark ? 'grey lighten-3' : 'grey darken-3'">
            <v-row class="mb-2" row wrap>
              <v-col xs3 sm3 class="mb-2 pr-4">
                <v-select
                  v-model="filters.tipoLabel"
                  label="Tipo"
                  placeholder="Filtrar"
                  item-text="label"
                  item-value="label"
                  color="accent"
                  small
                  clearable
                  multiple
                  chips
                  :items="tipo"
                />
              </v-col>
              <v-col
                xs3
                sm3
                class="mb-2 pr-4"
              >
                <v-select
                  v-model="filters.proveedor"
                  label="Proveedores"
                  placeholder="Filtrar"
                  item-text="nombre"
                  item-value="nombre"
                  color="accent"
                  small
                  multiple
                  chips
                  clearable
                  :items="proveedores"
                />
              </v-col>
            </v-row>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>

      <v-data-table
        v-model="selected"
        :items-per-page="10"
        :headers="headers"
        :items="filtradoLista"
        :search="search"
        class="elevation-1"
        item-key="idproductos"
        :show-select="seleccionable"
      >
        <template
          v-if="$vuetify.breakpoint.smAndDown"
          #[`header.data-table-select`]="{ on, props }"
        >
          <label>Todos</label>
          <v-simple-checkbox
            color="purple"
            v-bind="props"
            class="mr-12"
            v-on="on"
          />
        </template>
        <template #[`item.data-table-select`]="{ isSelected, select }">
          <v-simple-checkbox :value="isSelected" @input="select($event)" />
        </template>
        <template #[`item.precio_ingreso`]="props">
          <div>$ {{ props.item.precio_ingreso }}</div>
        </template>
        <template #[`item.total`]="props">
          <div v-if="props.item.stock">$ {{ props.item.precio_ingreso * props.item.stock }}</div>
          <div v-else>$ {{ props.item.precio_ingreso }}</div>
        </template>
        <template #[`item.fechaVencimiento`]="props">
          <v-chip
            v-if="fechaHoy(props.item.fecha_vencimiento) && props.item.fechaVencimiento !== 'No registrado'"
            color="red"
            dark
          >
            {{ props.item.fechaVencimiento }}
          </v-chip>
          <div v-else>
            {{ props.item.fechaVencimiento }}
          </div>
        </template>
        <template #[`item.cantidad`]="props">
          <v-edit-dialog>
            {{ props.item.cantidad }}
            <template #input>
              <v-text-field
                v-model="props.item.cantidad"
                label="Editar"
                single-line
              />
            </template>
          </v-edit-dialog>
        </template>
        <template #[`item.stock`]="props">
          <v-chip
            v-if="props.item.stock"
            :color="getColor(props.item.stock)"
            dark
          >
            {{ props.item.stock }}
          </v-chip>
          <div v-else>
            {{ props.item.stock }}
          </div>
        </template>
        <template #[`item.precio_venta`]="props">
          <v-edit-dialog>
            $ {{ props.item.precio_venta }}
            <template #input>
              <v-text-field
                v-model="props.item.precio_venta"
                label="Editar"
                single-line
              />
            </template>
          </v-edit-dialog>
        </template>
        <template v-if="seleccionable === false" #[`item.action`]="{ item }">
          <v-btn
            color="accent"
            small
            outlined
            class="mr-4"
            @click="renovarStock(item)"
          >
            Renovar Stock
          </v-btn>
          <v-icon
            small
            class="mr-2 fal fa-edit"
            @click="modificarProducto(item)"
          />
          <v-icon
            small
            class="fal fa-trash-alt"
            @click="eliminarProducto(item.idproductos)"
          />
        </template>
      </v-data-table>
    </v-card-text>
    <v-card-actions v-if="seleccionable" :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn class="elevation-2 font-weight-light secondary" @click="dialogAddProducto = true">
        Agregar nuevo
      </v-btn>
      <v-btn class="elevation-2 font-weight-light accent" @click="enviarSeleccionado">
        Ok
      </v-btn>
    </v-card-actions>
    <v-dialog v-model="dialogAddProducto" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-productos @onClose="dialogAddProducto=false" />
    </v-dialog>
  </v-card>
  <v-col v-else>
    <v-col class="mb-2">
      <v-row align="end">
        <v-btn v-if="$vuetify.breakpoint.smAndUp" color="accent" @click="abrirForm">
          <v-icon left>
            fal fa-plus
          </v-icon>
          Nuevo
        </v-btn>
        <v-btn v-if="$vuetify.breakpoint.smAndUp" class="ml-3" color="secondary" @click="abrirFormStock">
          <v-icon left>
            fal fa-engine-warning
          </v-icon>
          Generar reporte crítico
        </v-btn>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-expansion-panels
      hover
      flat
      multiple
      class="mt-8"
    >
      <v-expansion-panel>
        <v-expansion-panel-header color="rgba(141,88,193,0.34)">
          <v-row justify="start" align="center">
            <v-icon class="mr-2">
              fal fa-filter
            </v-icon><label>Filtros</label>
          </v-row>
        </v-expansion-panel-header>
        <v-expansion-panel-content :class="!$vuetify.theme.dark ? 'grey lighten-3' : 'grey darken-3'">
          <v-row class="mb-2" row wrap>
            <v-col xs3 sm3 class="mb-2 pr-4">
              <v-select
                v-model="filters.tipoLabel"
                label="Tipo"
                placeholder="Filtrar"
                item-text="label"
                item-value="label"
                color="accent"
                small
                clearable
                multiple
                chips
                :items="tipo"
              />
            </v-col>
            <v-col
              xs3
              sm3
              class="mb-2 pr-4"
            >
              <v-select
                v-model="filters.proveedor"
                label="Proveedores"
                placeholder="Filtrar"
                item-text="nombre"
                item-value="nombre"
                color="accent"
                small
                multiple
                chips
                clearable
                :items="proveedores"
              />
            </v-col>
          </v-row>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
    <v-data-table
      v-model="selected"
      :items-per-page="10"
      :headers="headers"
      :items="filtradoLista"
      :search="search"
      class="elevation-1"
      item-key="idproductos"
      :show-select="seleccionable"
    >
      <template #[`item.precio_ingreso`]="props">
        <div>$ {{ props.item.precio_ingreso }}</div>
      </template>
      <template #[`item.total`]="props">
        <div v-if="props.item.stock">$ {{ props.item.precio_ingreso * props.item.stock }}</div>
        <div v-else>$ {{ props.item.precio_ingreso }}</div>
      </template>
      <template #[`item.fechaVencimiento`]="props">
        <v-chip
          v-if="fechaHoy(props.item.fecha_vencimiento) && props.item.fechaVencimiento !== 'No registrado'"
          color="red"
          dark
        >
          {{ props.item.fechaVencimiento }}
        </v-chip>
        <div v-else>
          {{ props.item.fechaVencimiento }}
        </div>
      </template>
      <template #[`item.stock`]="props">
        <v-chip
          v-if="props.item.stock"
          :color="getColor(props.item.stock)"
          dark
        >
          {{ props.item.stock }}
        </v-chip>
        <div v-else>
          {{ props.item.stock }}
        </div>
      </template>
      <template #[`item.cantidad`]="props">
        <v-edit-dialog
          :return-value.sync="props.item.cantidad"
          @save="save"
          @cancel="cancel"
        >
          {{ props.item.cantidad }}
          <template #input>
            <v-text-field
              v-model="props.item.cantidad"
              label="Editar"
              single-line
              counter
            />
          </template>
        </v-edit-dialog>
      </template>
      <template #[`item.precio_venta`]="props">
        <v-edit-dialog
          :return-value.sync="props.item.precio_venta"
        >
          $ {{ props.item.precio_venta }}
          <template #input>
            <v-text-field
              v-model="props.item.precio_venta"
              label="Editar"
              single-line
              counter
            />
          </template>
        </v-edit-dialog>
      </template>
      <template v-if="seleccionable === false" #[`item.action`]="{ item }">
        <v-btn
          color="accent"
          small
          outlined
          class="mr-4"
          @click="renovarStock(item)"
        >
          Renovar Stock
        </v-btn>
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarProducto(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarProducto(item.idproductos)"
        />
      </template>
    </v-data-table>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import moment from 'moment'
import AppToast from '~/core/utils/AppToast'
import { Producto } from '~/core/models/producto'
import { ProductosStore } from '~/store/ProductosStore'
import FormProductos from '~/components/productos/formProductos.vue'
import { ProveedoresStore } from '~/store/ProveedoresStore'
import { Proveedor } from '~/core/models/proveedor'
import { getTipoProducto, TipoProductoEnum } from '~/core/enums/TipoProductoEnum'
import { EnumsHelpers } from '~/core/helpers/EnumsHelpers'
    @Component({
      components: { FormProductos }
    })
export default class listaProductos extends Vue {
        @Prop({ default: false }) seleccionable!:boolean;

        search = '';
        dialogAddProducto:boolean = false;

      filters = {
        tipoLabel: [],
        proveedor: []
      };

        headers = [
          this.seleccionable && this.$vuetify.breakpoint.smAndDown ? { text: 'Seleccione', align: 'left', value: 'data-table-select' } : { sortable: false },

          { text: 'Código', align: 'left', value: 'codigo' },
          { text: 'Tipo', align: 'left', value: 'tipoLabel' },
          { text: 'Producto', align: 'left', value: 'nombre' },
          { text: 'Proveedor', align: 'left', value: 'proveedor' },
          { text: 'Stock', align: 'left', value: 'stock' },
          { text: 'Fecha de vencimiento', align: 'left', value: 'fechaVencimiento' },
          { text: 'Precio de Ingreso', align: 'left', value: 'precio_ingreso' },
          { text: 'Edad de aplicación', align: 'left', value: 'edad_aplicacion' },
          !this.seleccionable ? { text: 'Total', align: 'left', value: 'total' } : { sortable: false },
          this.seleccionable ? { text: 'Cantidad', align: 'left', value: 'cantidad' } : { sortable: false },
          this.seleccionable ? { text: 'Precio de venta', align: 'left', value: 'precio_venta' } : { sortable: false },
          { value: 'action', align: 'right', sortable: false }

        ];

        selected:Producto[] = [];

        get productos ():Producto[] {
          return ProductosStore.listaProductos.map((p) => {
            const x:Proveedor = ProveedoresStore.listaProveedoresIndexed[p.proveedores_idproveedores]
            return {
              ...p,
              // categoria: x ? x.nombre : 'Desconocido',
              cantidad: 1,
              precio_venta: p.precio_ingreso,
              productos_idproductos: p.idproductos,
              proveedor: x ? x.nombre : 'No registrado',
              fechaVencimiento: p.fecha_vencimiento ? moment(p.fecha_vencimiento).format('DD/MM/YYYY') : 'No registrado',
              tipoLabel: getTipoProducto(p.tipo).label,
              edad_aplicacion: p.edad_aplicacion ? p.edad_aplicacion : 'No registrada'
            }
          })
        }

        get filtradoLista () {
          return this.productos.filter((d) => {
            return Object.keys(this.filters).every((f) => {
              return this.filters[f].length < 1 || this.filters[f].includes(d[f])
            })
          })
        }

        get proveedores () :Proveedor[] {
          return ProveedoresStore.listaProveedores
        }

        get tipo () {
          return EnumsHelpers.enumtolist(TipoProductoEnum).map(p => getTipoProducto(p.id))
        }

        enviarSeleccionado () {
          this.$emit('addProduct', this.selected)
        }

        modificarProducto (val) {
          this.$emit('onEdit', val)
        }

        renovarStock (val) {
          this.$emit('onRenovar', val)
        }

        eliminarProducto (id:number) {
          this.$confirm('¿Está seguro?').then(async (res) => {
            if (res) {
              await ProductosStore.eliminarProducto(id)
              AppToast.info('Producto eliminado')
            }
          }).catch()
        }

        cerrarDialog () {
          this.$emit('onClose')
        }

        abrirForm () {
          this.$emit('onAbrir')
        }

        abrirFormStock () {
          this.$emit('onAbrirStock')
        }

        getColor (stock) {
          if (stock <= 15) { return 'red' } else { return 'green' }
        }

        fechaHoy (date) {
          return moment().isAfter(date)
        }
}
</script>

<style lang="scss">

</style>
